
var disk = window.top.frames['Disk'];
var type = 'Works Sprd.';
var rowSplitter = '';
var colSplitter = '';

var style = '<style type="text/css"><body {background-color: black;margin-left: 0px;margin-top: 0px;margin-right: 0px;margin-bottom: 0px;}body,td,th {color: #FFFFFF;}</style>';
var headBegin = '<html><head><title>Nothing</title>';
var headEnd = '</head>';
var bodyBegin = '<body>';
var bodyEnd = '</body></html>';
var spreadSheetData = "";

var fileUp = false;
var currFile = -1;
var rows;
var cols;
var SpreadSheet;

function Open()
{
	OpenSpecific(prompt('Type the file name of the file you want to open',''));
}

function OpenSpecific(Name)
{
	if(disk.Disk.getType(Name) == 'Error: File Does Not Exist')
	{
		alert(disk.Disk.getType(Name));
	}
	else if(disk.Disk.getType(Name) != type)
	{
		alert('The file you type is of incorrect format!');
	}
	else
	{
		currFile = Name;
		//var str = new String("" + disk.getContents(Name));
		//eval(str.substring(2,disk.getContents(Name).length - 2));
		var str = disk.Disk.getContents(Name);
		str = str.split(rowSplitter);
		rows = parseInt(str[0]);
		cols = parseInt(str[1]);
		initSpread(rows,cols);
		for(var i = 0; i < rows; i++)
		{
			var s = str[i + 2];
			s = s.split(colSplitter);
			for(var z = 0; z < cols; z++)
			{
				SpreadSheet[i][z] = s[z+1];	
			}
		}
		createSpread();
	}
}

function Save()
{
	var d = new Date();
	var Name;
	
	if(currFile == -1)
	{
		Name = prompt('Type the name of the file you want to save.','');
		currFile = Name;
	}
	disk.Disk.saveFile(currFile,type,d.toDateString(),toCode());
}

function setSaveName(name)
{
	currFile = name;
}

function SaveAs()
{
	currFile = -1;
	Save();
}

function getSpreadData()
{
	//spreadSheetData = dataSplitter;
	updateSpreadSheetData();
	var str = '/*initSpread(' + rows + ',' + cols + ');';
	for(var i = 0; i < rows; i++)
	{
		for(var z = 0; z < cols; z++)
		{
			str += 'SpreadSheet[' + i + '][' + z + '] = \"' + SpreadSheet[i][z] + '\";';
		}
	}
	return str + '*/';
}

function toCode()
{
	updateSpreadSheetData();
	var str = rows + rowSplitter + cols;
	for(var i = 0; i < rows; i++)
	{
		str += rowSplitter;
		for(var z = 0; z < cols; z++)
		{
			str += colSplitter + SpreadSheet[i][z];
		}
	}
	return str;
}

function initSpread(r,c)
{
	rows = r;
	cols = c;
	
	SpreadSheet = new Array(rows);
	for(var i = 0; i < rows; i++)
		SpreadSheet[i] = new Array(cols);
		
	for(var i = 0; i < rows; i++)
	{
		for(var z = 0; z < cols; z++)
		{
			SpreadSheet[i][z] = "";	
		}
	}
}

function New()
{
	currFile = -1;
	if(fileUp)
	{
		if(confirm('Do You Want to Save The Current File?'))
			Save();
		NewSpread();
	}
	else
		NewSpread();
}

function NewSpread()
{
	var rps = prompt('Number Of Rows','');
	var cps = prompt('Number Of Cols','');
	
	rows = parseInt(rps);
	cols = parseInt(cps);
	
	try
	{
		SpreadSheet = new Array(rows);
		for(var i = 0; i < rows; i++)
			SpreadSheet[i] = new Array(cols);
		
		for(var i = 0; i < rows; i++)
		{
			for(var z = 0; z < cols; z++)
			{
				SpreadSheet[i][z] = "";	
			}
		}	
	
	}
	catch(error)
	{
		alert(error.message + '\nType In a Number');
		NewSpread();
	}
	
	createSpread();
}

function createSpread()
{
		
	spreadSheetData = '<table rows="' + rows + '"' + 'cols="' + cols + '"' + 'cellpadding="0" cellspacing="0"' + '>';
	for(var i = 0; i < rows; i++)
	{
		spreadSheetData += '<tr>';
		for(var z = 0; z < cols; z++)
		{
			spreadSheetData +=	'<td><input type="text" id="r' + i + 'c' + z + '"value=\"' + SpreadSheet[i][z] + '\"></td>';
		}
		spreadSheetData += '</tr>';
	}
	spreadSheetData += '</table>';
	
	updateSpreadHTML();
}

function updateSpreadSheetData()
{
	for(var i = 0; i < rows; i++)
	{
		for(var z = 0; z < cols; z++)
		{
			SpreadSheet[i][z] = frames['Window'].document.getElementById('r' + i + 'c' + z).value;	
		}
	}
}

function updateSpreadHTML()
{
	frames['Window'].document.open();
	frames['Window'].document.write(headBegin + style + headEnd + bodyBegin + spreadSheetData + bodyEnd);
	frames['Window'].document.close();
}

function checkRam()
{
	if(window.top.frames['Disk'].Disk.getRam() != null && window.top.frames['Disk'].Disk.getRam() != "")
	{
		currFile = window.top.frames['Disk'].Disk.getRam();
		window.top.frames['Disk'].Disk.clearRam();
		if(currFile != null && currFile != '')
			setTimeout('OpenSpecific(currFile)',500);
		//setTimeout("updateSpreadHTML()",1000);
	}
}

function test()
{
	//updateSpreadSheetData()
	//alert('SpreadSheet[' + 0 + '][' + 0 + '] = \"' + SpreadSheet[0][0] + '\";');
	//alert(getSpreadData());
	alert(disk.document.Disk.DiskText.value);
}